-- 1

-- metadata for url
CREATE TABLE IF NOT EXISTS url (
  urlid TEXT,
  title TEXT,
  catid INT,
  rating INT,
  rating_applied INT,
  comment_level INT DEFAULT 0,
  score INT DEFAULT 0,
  PRIMARY KEY ( urlid )
);
CREATE INDEX IF NOT EXISTS url__rate_event ON url( rating, rating_applied );

-- canonizing url map
CREATE TABLE IF NOT EXISTS url_map (
  url TEXT,
  urlid TEXT,
  PRIMARY KEY ( url )
);

-- canonizing tag map
CREATE TABLE IF NOT EXISTS tag_map (
  tag TEXT,
  tagid INT,
  PRIMARY KEY ( tag )
);
CREATE INDEX IF NOT EXISTS tag_map__tagid ON tag_map( tagid );

-- tags for url
CREATE TABLE IF NOT EXISTS url_tag (
  urlid TEXT,
  tagid INT,
  seq INT DEFAULT 0, -- tag display order
  tag_applied INT, -- when last applied
  UNIQUE ( urlid, tagid )
);
CREATE INDEX IF NOT EXISTS url_tag__urlid ON url_tag( urlid );
CREATE INDEX IF NOT EXISTS url_tag__tag_event ON url_tag( tag_applied );

CREATE TABLE IF NOT EXISTS supertopic (
  label TEXT,
  bm_folderid INT DEFAULT 0,
  PRIMARY KEY ( label )
  UNIQUE ( bm_folderid )
);

CREATE TABLE IF NOT EXISTS event_log (
  eventid INTEGER PRIMARY KEY AUTOINCREMENT,
  type TEXT,
  detail TEXT DEFAULT '',
  occurred INT
);
CREATE INDEX IF NOT EXISTS event_log__type_occurred ON event_log ( type, occurred );

CREATE TABLE IF NOT EXISTS settings (
  name TEXT PRIMARY KEY,
  value TEXT
);

CREATE TABLE IF NOT EXISTS blocked_domain (
  domain TEXT,
  modified INT,
  active INT,
  PRIMARY KEY (domain) ON CONFLICT REPLACE
);

CREATE TABLE IF NOT EXISTS command_queue (
  seqid INTEGER PRIMARY KEY AUTOINCREMENT,
  priority INT,
  command TEXT
);
CREATE INDEX IF NOT EXISTS command_queue__priority ON command_queue ( priority DESC, seqid );

